From 816cb146b7f58f0b7bb04727f0e4f591e97cd33f Mon Sep 17 00:00:00 2001
From: Michael Haubenwallner <michael.haubenwallner@ssi-schaefer.com>
Date: Tue, 4 Jun 2019 10:24:54 +0200
Subject: [PATCH 15/21] Support using parity to compile on windows.

---
 MakeVars.in                   | 17 ++++++++++++---
 auxdir/Makefile               |  9 ++++++--
 ccm/Makefile                  | 30 ++++++++++++++------------
 configure.in                  | 11 +++++++---
 coss/Makefile                 |  6 +++++-
 coss/events/Makefile          | 10 ++++-----
 coss/externalization/Makefile | 34 ++++++++++++++---------------
 coss/lifecycle/Makefile       | 40 +++++++++++++++++------------------
 coss/naming/Makefile          | 18 ++++++++--------
 coss/property/Makefile        | 10 ++++-----
 coss/relship/Makefile         | 40 +++++++++++++++++------------------
 coss/time/Makefile            | 10 ++++-----
 coss/trader/Makefile          | 10 ++++-----
 coss/wireless/Makefile        | 30 +++++++++++++-------------
 cpp/Makefile                  |  8 +++----
 daemon/Makefile               | 14 ++++++------
 idl/Makefile                  | 12 +++++------
 idl/params.cc                 |  2 ++
 ir/Makefile                   | 16 ++++++++------
 orb/Makefile                  | 20 +++++++++++++++++-
 orb/orb_all.cc                |  4 ++++
 tools/iordump/Makefile        |  6 +++---
 22 files changed, 207 insertions(+), 150 deletions(-)

diff --git a/MakeVars.in b/MakeVars.in
index 7e8890b..03ea816 100644
--- a/MakeVars.in
+++ b/MakeVars.in
@@ -28,6 +28,15 @@ INSTDIR		= @ABSEXECDIR@
 SHARED_INSTDIR	= @ABSSHRDDIR@
 
 OSTYPE          = @OSTYPE@
+SUBOSTYPE		= @SUBOSTYPE@
+EXEEXT =
+
+ifeq ($(OSTYPE), windows)
+ifeq ($(SUBOSTYPE), parity)
+EXEEXT = .exe
+endif
+endif
+
 # We need the compiler type, not just the os
 HAVE_MINGW	= @HAVE_MINGW@
 HAVE_CYGWIN	= @HAVE_CYGWIN@
@@ -129,9 +138,9 @@ DVIPDFM		= dvipdfm
 LATEX2HTML	= latex2html
 FIG2DEV		= fig2dev
 MKFAQ           = $(SRCDIR)/admin/mkfaq
-IDL		= @IDL@
-IDLGEN		= @IDL@
-CCMGEN          = @CCMGEN@
+IDL		= @IDL@$(EXEEXT)
+IDLGEN		= @IDL@$(EXEEXT)
+CCMGEN          = @CCMGEN@$(EXEEXT)
 MKDEPEND	= @MKDEPEND@
 # on some Solaris systems strip does not support ELF binaries ...
 IBINCMD         = $(SRCDIR)/admin/install-sh -c -m 755
@@ -177,6 +186,7 @@ LDMICOAUX              = -lmicoaux$(VERSION)
 LDMICOCCM              = -lmicoccm$(VERSION)
 
 ifeq ($(OSTYPE), windows)
+ifneq ($(SUBOSTYPE), parity)
 ifeq ($(HAVE_SHARED), yes)
 export PATH           := @LIBPATH@:$(PATH)
 NODOTVERSION           = $(shell tr -d \. < $(SRCDIR)/VERSION)
@@ -187,6 +197,7 @@ LIBMICOAUX	       = libmicoaux$(VERSION).a
 LIBMICOCOSS	       = libmicocoss$(VERSION).a
 endif
 endif
+endif
 
 export PATH           := @CPPPATH@:$(PATH):.
 
diff --git a/auxdir/Makefile b/auxdir/Makefile
index c283147..533460c 100644
--- a/auxdir/Makefile
+++ b/auxdir/Makefile
@@ -127,6 +127,7 @@ endif
 		-L../libs $(LDMICO)
 	$(IDIRCMD) ../libs
 	cd ../libs; rm -f $@; $(LN) ../auxdir/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../auxdir/$@.dll . )
 
 libmicox$(VERSION).$(SOEXT): $(SHARED_X11_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -137,6 +138,7 @@ endif
 		$(PURE_LDFLAGS) -lXt -lX11 -L../libs $(LDMICO) $(PLATFORM_LIBS)
 	$(IDIRCMD) ../libs
 	cd ../libs; rm -f $@; $(LN) ../auxdir/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../auxdir/$@.dll . )
 
 libmicoqt$(VERSION).$(SOEXT): $(SHARED_QT_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -147,6 +149,7 @@ endif
 		$(PURE_LDFLAGS) $(QT_LIBS) -L../libs $(LDMICO)
 	$(IDIRCMD) ../libs
 	cd ../libs; rm -f $@; $(LN) ../auxdir/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../auxdir/$@.dll . )
 
 libmicogtk$(VERSION).$(SOEXT): $(SHARED_GTK_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -157,6 +160,7 @@ endif
 		$(PURE_LDFLAGS) $(GTK_LIBS) -L../libs $(LDMICO)
 	$(IDIRCMD) ../libs
 	cd ../libs; rm -f $@; $(LN) ../auxdir/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../auxdir/$@.dll . )
 
 libmicotcl$(VERSION).$(SOEXT): $(SHARED_TCL_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -167,6 +171,7 @@ endif
 		$(PURE_LDFLAGS) $(TCL_LIBS) -L../libs $(LDMICO)
 	$(IDIRCMD) ../libs
 	cd ../libs; rm -f $@; $(LN) ../auxdir/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../auxdir/$@.dll . )
 
 
 # static
@@ -220,14 +225,14 @@ endif
 # cleaning
 
 clean:
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.moc
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.moc *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) *.orig
 
 install:
 	$(IDIRCMD) $(INSTDIR)/lib
 ifeq ($(HAVE_SHARED), yes)
-	@for i in $(SHARED_LIBS); do $(ILIBCMD) $$i $(INSTDIR)/lib; done
+	@for i in $(SHARED_LIBS); do $(ILIBCMD) $$i $(INSTDIR)/lib; test ! -f $$i.dll || $(ILIBCMD) $$i.dll $(INSTDIR)/lib; done
 endif
 ifeq ($(HAVE_STATIC), yes)
 	@for i in $(STATIC_LIBS); do $(ILIBCMD) $$i $(INSTDIR)/lib; done
diff --git a/ccm/Makefile b/ccm/Makefile
index f726403..2480cb5 100644
--- a/ccm/Makefile
+++ b/ccm/Makefile
@@ -49,11 +49,13 @@ SHARED_OBJS=$(STATIC_OBJS:.o=.pic.o)
 # mingw hack
 
 ifeq ($(OSTYPE), windows)
+ifneq ($(SUBOSTYPE), parity)
 ifeq ($(HAVE_SHARED), yes)
 HAVE_SHARED := no
 HAVE_STATIC := yes
 endif
 endif
+endif
 
 # normal rules
 
@@ -65,15 +67,15 @@ ifeq ($(HAVE_SHARED), yes)
 LIBMICOCCM := libmicoccm$(VERSION).$(SOEXT)
 ifeq ($(HAVE_STATIC), yes)
 prg: .depend libmicoccm$(VERSION).$(SOEXT) libmicoccm$(VERSION).a \
-	mico-ccm componentserver mico-ccmd ccmload
+	mico-ccm$(EXEEXT) componentserver$(EXEEXT) mico-ccmd$(EXEEXT) ccmload$(EXEEXT)
 else
 prg: .depend libmicoccm$(VERSION).$(SOEXT) \
-	mico-ccm componentserver mico-ccmd ccmload
+	mico-ccm$(EXEEXT) componentserver$(EXEEXT) mico-ccmd$(EXEEXT) ccmload$(EXEEXT)
 endif
 else
 LIBMICOCCM := libmicoccm$(VERSION).a
 prg: .depend libmicoccm$(VERSION).a \
-	mico-ccm componentserver mico-ccmd ccmload
+	mico-ccm$(EXEEXT) componentserver$(EXEEXT) mico-ccmd$(EXEEXT) ccmload$(EXEEXT)
 endif
 else
 all:
@@ -81,17 +83,17 @@ lib:
 prg:
 endif
 
-mico-ccm: ../idl/libidl.a ../orb/$(LIBMICO) ../ir/$(LIBMICOIR) $(LIBMICOCCM) mico-ccm.o
+mico-ccm$(EXEEXT): ../idl/libidl.a ../orb/$(LIBMICO) ../ir/$(LIBMICOIR) $(LIBMICOCCM) mico-ccm.o
 	$(CXX) -o $@ $(LDFLAGS) mico-ccm.o -L. $(LDMICOCCM) $(LDMICOIR) $(LDLIBS)
 	$(POSTLD) $@
 
-componentserver: ../orb/$(LIBMICO) $(LIBMICOCCM) componentserver.o
+componentserver$(EXEEXT): ../orb/$(LIBMICO) $(LIBMICOCCM) componentserver.o
 	$(CXX) -o $@ $(LDFLAGS) componentserver.o -L. $(LDMICOCCM) $(LDLIBS)
 
-mico-ccmd: ../orb/$(LIBMICO) $(LIBMICOCCM) mico-ccmd.o
+mico-ccmd$(EXEEXT): ../orb/$(LIBMICO) $(LIBMICOCCM) mico-ccmd.o
 	$(CXX) -o $@ $(LDFLAGS) mico-ccmd.o -L. $(LDMICOCCM) $(LDLIBS)
 
-ccmload: ../orb/$(LIBMICO) $(LIBMICOCCM) ccmload.o
+ccmload$(EXEEXT): ../orb/$(LIBMICO) $(LIBMICOCCM) ccmload.o
 	$(CXX) -o $@ $(LDFLAGS) ccmload.o -L. $(LDMICOCCM) $(LDMICOCOSS) $(LDLIBS)
 
 libmicoccm$(VERSION).$(SOEXT): $(SHARED_OBJS)
@@ -105,6 +107,7 @@ endif
 	$(LDSO) -o libmicoccm$(VERSION) $(SHARED_OBJS) -L../libs $(LDMICO) $(PLATFORM_LIBS)
 	$(IDIRCMD) ../libs
 	cd ../libs; $(RM) $@; $(LN) ../ccm/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../ccm/$@.dll . )
 
 libmicoccm$(VERSION).a: $(STATIC_OBJS)
 ifeq ($(HAVE_REPO), yes)
@@ -121,22 +124,23 @@ endif
 # cleaning
 
 clean:
-	-$(RM) mico-ccmd ccmload componentserver mico-ccm libmicoccm*
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid
+	-$(RM) mico-ccmd$(EXEEXT) ccmload$(EXEEXT) componentserver$(EXEEXT) mico-ccm$(EXEEXT) libmicoccm*
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out
 
 install: all
 ifeq ($(USE_CCM), yes)
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) mico-ccm $(INSTDIR)/bin
-	$(IBINCMD) componentserver $(INSTDIR)/bin
-	$(IBINCMD) mico-ccmd $(INSTDIR)/bin
-	$(IBINCMD) ccmload $(INSTDIR)/bin
+	$(IBINCMD) mico-ccm$(EXEEXT) $(INSTDIR)/bin
+	$(IBINCMD) componentserver$(EXEEXT) $(INSTDIR)/bin
+	$(IBINCMD) mico-ccmd$(EXEEXT) $(INSTDIR)/bin
+	$(IBINCMD) ccmload$(EXEEXT) $(INSTDIR)/bin
 ifeq ($(HAVE_STATIC), yes)
 	$(ILIBCMD) libmicoccm$(VERSION).a $(INSTDIR)/lib
 endif
 ifeq ($(HAVE_SHARED), yes)
 	$(ILIBCMD) libmicoccm$(VERSION).$(SOEXT) $(INSTDIR)/lib
+	test -t libmicoccm$(VERSION).$(SOEXT).dll && $(ILIBCMD) libmicoccm$(VERSION).$(SOEXT).dll $(INSTDIR)/lib
 endif
 endif
 
diff --git a/configure.in b/configure.in
index 21430ff..ccc7044 100644
--- a/configure.in
+++ b/configure.in
@@ -375,11 +375,15 @@ AC_LANG_CPLUSPLUS
 AC_MSG_CHECKING(OS Type)
 gxxversion=`$CXX -v 2>&1`
 case $gxxversion in
-*mingw*special*)
+*mingw*special*|*parity*)
 	#
-	# This is the MinGW compiler in a Cygwin environment
+	# This is the MinGW compiler in a Cygwin environment,
+	# or the parity compiler in an interix environment
 	#
 	OSTYPE=windows
+	case $gxxversion in
+	*parity*) SUBOSTYPE=parity ;;
+	esac
 	RMPROG="rm -f"
 	LNPROG="cp"
 	;;
@@ -389,8 +393,9 @@ case $gxxversion in
 	LNPROG="ln -f -s"
 	;;
 esac
-AC_MSG_RESULT($OSTYPE)
+AC_MSG_RESULT([$OSTYPE ($SUBOSTYPE)])
 AC_SUBST(OSTYPE)
+AC_SUBST(SUBOSTYPE)
 AC_SUBST(RMPROG)
 AC_SUBST(LNPROG)
 
diff --git a/coss/Makefile b/coss/Makefile
index 04c1d28..c3701c7 100644
--- a/coss/Makefile
+++ b/coss/Makefile
@@ -193,12 +193,14 @@ SHARED_OBJS = $(STATIC_OBJS:.o=.pic.o)
 # mingw hack
 
 ifeq ($(OSTYPE), windows)
+ifneq ($(SUBOSTYPE), parity)
 ifeq ($(HAVE_SHARED), yes)
 HAVE_SHARED_EXCEPTS := no
 HAVE_SHARED := no
 HAVE_STATIC := yes
 endif
 endif
+endif
 
 
 all: lib prg
@@ -241,6 +243,7 @@ endif
 		-L../libs $(LDMICO) $(PLATFORM_LIBS)
 	$(IDIRCMD) ../libs
 	cd ../libs; $(RM) $@; $(LN) ../coss/$@ .
+	test ! -f $@.dll || ( cd ../libs; rm -f $@.dll; $(LN) ../coss/$@.dll . )
 endif
 
 # static
@@ -261,7 +264,7 @@ endif
 
 clean:
 	for i in $(CLEANDIRS); do $(MAKE) -C $$i clean || exit 1; done
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.objid
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.objid *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out
 
 idlcompile:
@@ -274,6 +277,7 @@ install:
 ifneq ($(strip $(SUBDIRS)),)
 ifeq ($(HAVE_SHARED_EXCEPTS), yes)
 	$(ILIBCMD) libmicocoss$(VERSION).$(SOEXT) $(INSTDIR)/lib
+	test ! -f libmicocoss$(VERSION).$(SOEXT).dll || $(ILIBCMD) libmicocoss$(VERSION).$(SOEXT).dll $(INSTDIR)/lib
 ifeq ($(HAVE_STATIC), yes)
 	$(ILIBCMD) libmicocoss$(VERSION).a $(INSTDIR)/lib
 endif
diff --git a/coss/events/Makefile b/coss/events/Makefile
index 30c9427..4afd246 100644
--- a/coss/events/Makefile
+++ b/coss/events/Makefile
@@ -51,12 +51,12 @@ else
 lib:
 endif
 
-prg: .depend eventd
+prg: .depend eventd$(EXEEXT)
 
 idlcompile: CosEventComm.cc CosEventChannelAdmin.cc
 
-eventd: $(SRV_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o eventd
+eventd$(EXEEXT): $(SRV_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 CosEventComm.h CosEventComm.cc: ../../include/coss/CosEventComm.idl $(IDL)
@@ -74,7 +74,7 @@ CosEventChannelAdmin.h CosEventChannelAdmin.cc: \
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid eventd
+	-$(RM) *.o *.a *~ *.rpo *.objid eventd$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosEventChannelAdmin.h CosEventChannelAdmin.cc 
 	-$(RM) ../../include/coss/CosEventChannelAdmin.h
@@ -83,7 +83,7 @@ clean:
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) eventd $(INSTDIR)/bin
+	$(IBINCMD) eventd$(EXEEXT) $(INSTDIR)/bin
 
 ifeq (.depend, $(wildcard .depend))
 include .depend
diff --git a/coss/externalization/Makefile b/coss/externalization/Makefile
index fcdba24..c35a0bd 100644
--- a/coss/externalization/Makefile
+++ b/coss/externalization/Makefile
@@ -63,26 +63,26 @@ else
 lib: .depend $(STATIC_OBJS)
 endif
 
-prg: .depend extnoded extcontainmentd extreferenced streamd extcriteriad
+prg: .depend extnoded$(EXEEXT) extcontainmentd$(EXEEXT) extreferenced$(EXEEXT) streamd$(EXEEXT) extcriteriad$(EXEEXT)
 
-streamd: streamd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) streamd.o $(LDLIBS) -o streamd
+streamd$(EXEEXT): streamd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) streamd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-extnoded: extnoded.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) extnoded.o $(LDLIBS) -o extnoded
+extnoded$(EXEEXT): extnoded.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) extnoded.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-extcriteriad: extcriteriad.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) extcriteriad.o $(LDLIBS) -o extcriteriad
+extcriteriad$(EXEEXT): extcriteriad.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) extcriteriad.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-extcontainmentd: extcontainmentd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) extcontainmentd.o $(LDLIBS) -o extcontainmentd
+extcontainmentd$(EXEEXT): extcontainmentd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) extcontainmentd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-extreferenced: extreferenced.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) extreferenced.o $(LDLIBS) -o extreferenced
+extreferenced$(EXEEXT): extreferenced.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) extreferenced.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 idlcompile: CosExternalization.cc CosExternalizationContainment.cc CosExternalizationReference.cc
@@ -109,7 +109,7 @@ CosExternalizationReference.h CosExternalizationReference.cc: \
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid extnoded extcontainmentd extreferenced streamd extcriteriad
+	-$(RM) *.o *.a *~ *.rpo *.objid extnoded$(EXEEXT) extcontainmentd$(EXEEXT) extreferenced$(EXEEXT) streamd$(EXEEXT) extcriteriad$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosExternalization.h CosExternalization.cc
 	-$(RM) ../../include/coss/CosExternalization.h
@@ -120,15 +120,15 @@ clean:
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) streamd $(INSTDIR)/bin
+	$(IBINCMD) streamd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) extnoded $(INSTDIR)/bin
+	$(IBINCMD) extnoded$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) extcontainmentd $(INSTDIR)/bin
+	$(IBINCMD) extcontainmentd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) extreferenced $(INSTDIR)/bin
+	$(IBINCMD) extreferenced$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) extcriteriad $(INSTDIR)/bin
+	$(IBINCMD) extcriteriad$(EXEEXT) $(INSTDIR)/bin
 
 
 ifeq (.depend, $(wildcard .depend))
diff --git a/coss/lifecycle/Makefile b/coss/lifecycle/Makefile
index 1ebced1..5fe3160 100644
--- a/coss/lifecycle/Makefile
+++ b/coss/lifecycle/Makefile
@@ -71,34 +71,34 @@ else
 lib: .depend $(STATIC_OBJS)
 endif
 
-prg: .depend lifenoded lifecontainmentd lifereferenced operationd lifecriteriad factoryfinderd genericfactory
+prg: .depend lifenoded$(EXEEXT) lifecontainmentd$(EXEEXT) lifereferenced$(EXEEXT) operationd$(EXEEXT) lifecriteriad$(EXEEXT) factoryfinderd$(EXEEXT) genericfactory$(EXEEXT)
 
-operationd: operationd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) operationd.o $(LDLIBS) -o operationd
+operationd$(EXEEXT): operationd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) operationd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-lifenoded: lifenoded.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifenoded.o $(LDLIBS) -o lifenoded
+lifenoded$(EXEEXT): lifenoded.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifenoded.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-lifecontainmentd: lifecontainmentd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifecontainmentd.o $(LDLIBS) -o lifecontainmentd
+lifecontainmentd$(EXEEXT): lifecontainmentd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifecontainmentd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-lifereferenced: lifereferenced.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifereferenced.o  $(LDLIBS) -o lifereferenced
+lifereferenced$(EXEEXT): lifereferenced.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifereferenced.o  $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-lifecriteriad: lifecriteriad.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifecriteriad.o $(LDLIBS) -o lifecriteriad
+lifecriteriad$(EXEEXT): lifecriteriad.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) lifecriteriad.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-factoryfinderd: factoryfinderd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) factoryfinderd.o $(LDLIBS) -o factoryfinderd
+factoryfinderd$(EXEEXT): factoryfinderd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) factoryfinderd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-genericfactory: genericfactory.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) genericfactory.o $(LDLIBS) -o genericfactory
+genericfactory$(EXEEXT): genericfactory.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) genericfactory.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 idlcompile: CosLifeCycle.cc CosCompoundLifeCycle.cc CosLifeCycleContainment.cc CosLifeCycleReference.cc
@@ -131,7 +131,7 @@ CosLifeCycleReference.h CosLifeCycleReference.cc: \
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid lifenoded lifecontainmentd lifereferenced operationd lifecriteriad factoryfinderd genericfactory
+	-$(RM) *.o *.a *~ *.rpo *.objid lifenoded$(EXEEXT) lifecontainmentd$(EXEEXT) lifereferenced$(EXEEXT) operationd$(EXEEXT) lifecriteriad$(EXEEXT) factoryfinderd$(EXEEXT) genericfactory$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosLifeCycle.h CosLifeCycle.cc
 	-$(RM) ../../include/coss/CosLifeCycle.h
@@ -144,13 +144,13 @@ clean:
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) operationd $(INSTDIR)/bin
+	$(IBINCMD) operationd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) lifenoded $(INSTDIR)/bin
+	$(IBINCMD) lifenoded$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) lifecontainmentd $(INSTDIR)/bin
+	$(IBINCMD) lifecontainmentd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) lifereferenced $(INSTDIR)/bin
+	$(IBINCMD) lifereferenced$(EXEEXT) $(INSTDIR)/bin
 
 
 ifeq (.depend, $(wildcard .depend))
diff --git a/coss/naming/Makefile b/coss/naming/Makefile
index 69ec911..5c112ae 100644
--- a/coss/naming/Makefile
+++ b/coss/naming/Makefile
@@ -51,36 +51,36 @@ else
 lib:
 endif
 
-prg: .depend nsd nsadmin
+prg: .depend nsd$(EXEEXT) nsadmin$(EXEEXT)
 
 idlcompile: CosNaming.cc CosNaming_skel.cc
 
-nsd: $(SRV_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o nsd
+nsd$(EXEEXT): $(SRV_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-nsadmin: $(CLNT_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CLNT_OBJS) $(ALLLIBS) -o nsadmin
+nsadmin$(EXEEXT): $(CLNT_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CLNT_OBJS) $(ALLLIBS) -o $@
 	$(POSTLD) $@
 
 
 CosNaming.h CosNaming.cc CosNaming_skel.cc .NOTPARALLEL: ../../include/coss/CosNaming.idl $(IDL)
-	$(IDL) $(IDLFLAGS) --c++-skel --name CosNaming \
+	$(IDL) $(IDLFLAGS) --c++-skel --name CosNaming --windows-dll cossnaming \
 		../../include/coss/CosNaming.idl
 	cp CosNaming.h ../../include/coss
 
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.ii *.ti *.objid nsd nsadmin
+	-$(RM) *.o *.a *~ *.rpo *.ii *.ti *.objid nsd$(EXEEXT) nsadmin$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosNaming.h CosNaming.cc ../../include/coss/CosNaming.h \
 		CosNaming_skel.cc
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) nsd $(INSTDIR)/bin
-	$(IBINCMD) nsadmin $(INSTDIR)/bin
+	$(IBINCMD) nsd$(EXEEXT) $(INSTDIR)/bin
+	$(IBINCMD) nsadmin$(EXEEXT) $(INSTDIR)/bin
 
 ifeq (.depend, $(wildcard .depend))
 include .depend
diff --git a/coss/property/Makefile b/coss/property/Makefile
index b5caa90..c3b6975 100644
--- a/coss/property/Makefile
+++ b/coss/property/Makefile
@@ -52,12 +52,12 @@ else
 lib:
 endif
 
-prg: .depend propertyd
+prg: .depend propertyd$(EXEEXT)
 
 idlcompile: PropertyService.cc
 
-propertyd: $(SRV_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o propertyd
+propertyd$(EXEEXT): $(SRV_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 PropertyService.h PropertyService.cc: ../../include/coss/PropertyService.idl $(IDL)
@@ -72,11 +72,11 @@ clean:
 	-$(RM) *.o *.a *~ *.rpo *.objid
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) PropertyService.h PropertyService.cc ../../include/coss/PropertyService.h
-	-$(RM) propertyd
+	-$(RM) propertyd$(EXEEXT)
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) propertyd $(INSTDIR)/bin
+	$(IBINCMD) propertyd$(EXEEXT) $(INSTDIR)/bin
 
 ifeq (.depend, $(wildcard .depend))
 include .depend
diff --git a/coss/relship/Makefile b/coss/relship/Makefile
index 4caaf9a..fe99c02 100644
--- a/coss/relship/Makefile
+++ b/coss/relship/Makefile
@@ -70,32 +70,32 @@ else
 lib:
 endif
 
-prg: .depend traversald noded containmentd referenced randomd proxyd
+prg: .depend traversald$(EXEEXT) noded$(EXEEXT) containmentd$(EXEEXT) referenced$(EXEEXT) randomd$(EXEEXT) proxyd$(EXEEXT)
 
 idlcompile: $(OMG_SRCS) $(EXT_SRCS)
 
-traversald: traversald.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) traversald.o $(LDLIBS) -o traversald
+traversald$(EXEEXT): traversald.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) traversald.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-noded: noded.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) noded.o $(LDLIBS) -o noded
+noded$(EXEEXT): noded.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) noded.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-containmentd: containmentd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) containmentd.o $(LDLIBS) -o containmentd
+containmentd$(EXEEXT): containmentd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) containmentd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-referenced: referenced.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) referenced.o $(LDLIBS) -o referenced
+referenced$(EXEEXT): referenced.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) referenced.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-randomd: randomd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) randomd.o $(LDLIBS) -o randomd
+randomd$(EXEEXT): randomd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) randomd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-proxyd: proxyd.o ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) proxyd.o $(LDLIBS) -o proxyd
+proxyd$(EXEEXT): proxyd.o ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) proxyd.o $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 CosObjectIdentity.h CosObjectIdentity.cc: \
@@ -150,7 +150,7 @@ random.h random.cc: \
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid traversald noded containmentd referenced randomd proxyd
+	-$(RM) *.o *.a *~ *.rpo *.objid traversald$(EXEEXT) noded$(EXEEXT) containmentd$(EXEEXT) referenced$(EXEEXT) randomd$(EXEEXT) proxyd$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosObjectIdentity.h CosObjectIdentity.cc
 	-$(RM) ../../include/coss/CosObjectIdentity.h
@@ -171,17 +171,17 @@ clean:
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) traversald $(INSTDIR)/bin
+	$(IBINCMD) traversald$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) noded $(INSTDIR)/bin
+	$(IBINCMD) noded$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) containmentd $(INSTDIR)/bin
+	$(IBINCMD) containmentd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) referenced $(INSTDIR)/bin
+	$(IBINCMD) referenced$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) randomd $(INSTDIR)/bin
+	$(IBINCMD) randomd$(EXEEXT) $(INSTDIR)/bin
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) proxyd $(INSTDIR)/bin
+	$(IBINCMD) proxyd$(EXEEXT) $(INSTDIR)/bin
 
 
 ifeq (.depend, $(wildcard .depend))
diff --git a/coss/time/Makefile b/coss/time/Makefile
index 3a63e05..548adb8 100644
--- a/coss/time/Makefile
+++ b/coss/time/Makefile
@@ -50,12 +50,12 @@ else
 lib:
 endif
 
-prg: .depend timed
+prg: .depend timed$(EXEEXT)
 
 idlcompile: CosTime.cc
 
-timed: $(SRV_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o timed
+timed$(EXEEXT): $(SRV_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 CosTime.h CosTime.cc: ../../include/coss/CosTime.idl $(IDL)
@@ -74,14 +74,14 @@ generate:
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid timed
+	-$(RM) *.o *.a *~ *.rpo *.objid timed$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosTime.h CosTime.cc
 	-$(RM) ../../include/coss/CosTime.h
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) timed $(INSTDIR)/bin
+	$(IBINCMD) timed$(EXEEXT) $(INSTDIR)/bin
 
 ifeq (.depend, $(wildcard .depend))
 include .depend
diff --git a/coss/trader/Makefile b/coss/trader/Makefile
index b9b451a..3d2f514 100644
--- a/coss/trader/Makefile
+++ b/coss/trader/Makefile
@@ -62,12 +62,12 @@ else
 lib:
 endif
 
-prg: .depend traderd
+prg: .depend traderd$(EXEEXT)
 
 idlcompile: CosTrading.cc CosTrading_skel.cc CosTradingRepos.cc CosTradingRepos_skel.cc
 
-traderd: $(SRV_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o traderd
+traderd$(EXEEXT): $(SRV_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SRV_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 
@@ -83,7 +83,7 @@ CosTradingRepos.h CosTradingRepos.cc CosTradingRepos_skel.cc .NOTPARALLEL: ../..
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo *.objid traderd
+	-$(RM) *.o *.a *~ *.rpo *.objid traderd$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out
 	-$(RM) CosTrading.h CosTrading.cc CosTradingRepos.h CosTradingRepos.cc
 	-$(RM) ../../include/coss/CosTrading.h ../../include/coss/CosTradingRepos.h
@@ -91,7 +91,7 @@ clean:
 
 install:
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) traderd $(INSTDIR)/bin
+	$(IBINCMD) traderd$(EXEEXT) $(INSTDIR)/bin
 
 generate:
 	$(BISON) -d -t -v -o yacc.c yacc.yy
diff --git a/coss/wireless/Makefile b/coss/wireless/Makefile
index 473671b..922990c 100644
--- a/coss/wireless/Makefile
+++ b/coss/wireless/Makefile
@@ -21,15 +21,15 @@ include ../../MakeVars
 TARGETS =
 
 ifeq ($(USE_WIRELESS_HOME), yes)
-TARGETS := $(TARGETS) hla
+TARGETS := $(TARGETS) hla$(EXEEXT)
 endif
 
 ifeq ($(USE_WIRELESS_TERMINAL), yes)
-TARGETS := $(TARGETS) tadmin tb
+TARGETS := $(TARGETS) tadmin$(EXEEXT) tb$(EXEEXT)
 endif
 
 ifeq ($(USE_WIRELESS_ACCESS), yes)
-TARGETS := $(TARGETS) callback nadmin ab
+TARGETS := $(TARGETS) callback$(EXEEXT) nadmin$(EXEEXT) ab$(EXEEXT)
 endif
 
 LDLIBS    = $(LDMICOCOSS) $(LDMICO) $(CONFLIBS)
@@ -65,28 +65,28 @@ prg: .depend $(TARGETS)
 
 idlcompile: MobileTerminal.cc GTP.cc MobileTerminalNotification.cc
 
-hla: $(HLA_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(HLA_OBJS) $(LDLIBS) -o hla
+hla$(EXEEXT): $(HLA_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(HLA_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-tb: $(TB_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TB_OBJS) $(LDLIBS) -o tb
+tb$(EXEEXT): $(TB_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TB_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-ab: $(AB_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(AB_OBJS) $(LDLIBS) -o ab
+ab$(EXEEXT): $(AB_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(AB_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-callback: $(CB_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CB_OBJS) $(LDLIBS) -o callback
+callback$(EXEEXT): $(CB_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CB_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-tadmin: $(TAD_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TAD_OBJS) $(LDLIBS) -o tadmin
+tadmin$(EXEEXT): $(TAD_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TAD_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-nadmin: $(NAD_OBJS) ../../orb/$(LIBMICO)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(NAD_OBJS) $(LDLIBS) -o nadmin
+nadmin$(EXEEXT): $(NAD_OBJS) ../../orb/$(LIBMICO)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(NAD_OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 MobileTerminal.cc MobileTerminal.h: \
diff --git a/cpp/Makefile b/cpp/Makefile
index 8474c08..7adbcc8 100644
--- a/cpp/Makefile
+++ b/cpp/Makefile
@@ -40,24 +40,24 @@ OBJS=cexp.o cccp.o config.o alloca.o
 
 all: lib prg
 
-prg: .depend mico-cpp
+prg: .depend mico-cpp$(EXEEXT)
 
 lib: .depend
 
-mico-cpp: $(OBJS)
+mico-cpp$(EXEEXT): $(OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) $(OBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
 # cleaning
 
 clean:
-	-$(RM) *.o *.a *~ *.rpo mico-cpp
+	-$(RM) *.o *.a *~ *.rpo mico-cpp$(EXEEXT)
 	-$(RM) .depend TAGS core nohup.out $(GENERATED)
 
 
 install: all
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) mico-cpp $(INSTDIR)/bin
+	$(IBINCMD) mico-cpp$(EXEEXT) $(INSTDIR)/bin
 
 install-cd: install
 
diff --git a/daemon/Makefile b/daemon/Makefile
index e43b105..ea17b53 100644
--- a/daemon/Makefile
+++ b/daemon/Makefile
@@ -38,13 +38,13 @@ IMRCLOBJS=imr_client.o
 
 all: prg
 
-prg: .depend micod imr
+prg: .depend micod$(EXEEXT) imr$(EXEEXT)
 
-micod: $(MICODOBJS) ../orb/$(LIBMICO)
+micod$(EXEEXT): $(MICODOBJS) ../orb/$(LIBMICO)
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(MICODOBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
-imr: $(IMRCLOBJS) ../orb/$(LIBMICO)
+imr$(EXEEXT): $(IMRCLOBJS) ../orb/$(LIBMICO)
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(IMRCLOBJS) $(LDLIBS) -o $@
 	$(POSTLD) $@
 
@@ -75,15 +75,15 @@ diffs:
 # cleaning
 
 clean:
-	-$(RM) micod imr
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid
+	-$(RM) micod$(EXEEXT) imr$(EXEEXT)
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out
 
 
 install: all
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) micod $(INSTDIR)/bin
-	$(IBINCMD) imr $(INSTDIR)/bin
+	$(IBINCMD) micod$(EXEEXT) $(INSTDIR)/bin
+	$(IBINCMD) imr$(EXEEXT) $(INSTDIR)/bin
 
 install-cd: install
 
diff --git a/idl/Makefile b/idl/Makefile
index 756133b..85bac8b 100644
--- a/idl/Makefile
+++ b/idl/Makefile
@@ -56,7 +56,7 @@ endif
 
 all: lib prg
 
-prg: .depend idl
+prg: .depend idl$(EXEEXT)
 
 lib: .depend libidl.a $(OBJS)
 
@@ -71,8 +71,8 @@ endif
 	$(AR) $(ARFLAGS) $@ $(OBJS)
 	$(RANLIB) $@
 
-idl: libidl.a main.o ../orb/$(LIBMICO) ../ir/$(LIBMICOIR) $(IR_OBJS)
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) main.o $(IR_OBJS) $(LDLIBS) libidl.a -o idl
+idl$(EXEEXT): libidl.a main.o ../orb/$(LIBMICO) ../ir/$(LIBMICOIR) $(IR_OBJS)
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) main.o $(IR_OBJS) $(LDLIBS) libidl.a -o $@
 	$(POSTLD) $@
 
 main.o:
@@ -80,14 +80,14 @@ main.o:
 # cleaning
 
 clean:
-	-$(RM) idl idl.install
-	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid
+	-$(RM) idl$(EXEEXT) idl.install
+	-$(RM) *.o *.o0 *.a *~ *.$(SOEXT) *.exe *.rpo *.ii *.ti *.objid *.dll *.pdb *.exp
 	-$(RM) .depend TAGS core nohup.out $(GENERATED)
 
 
 install: all
 	$(IDIRCMD) $(INSTDIR)/bin
-	$(IBINCMD) idl $(INSTDIR)/bin
+	$(IBINCMD) idl$(EXEEXT) $(INSTDIR)/bin
 
 install-cd: install
 
diff --git a/idl/params.cc b/idl/params.cc
index fc15b35..a37690a 100644
--- a/idl/params.cc
+++ b/idl/params.cc
@@ -72,11 +72,13 @@ IDLParam::set_defaults()
   cpp = "mico-cpp";
 #else // _WIN32
   cpp = "mico-cpp.exe";
+#ifndef __PARITY__
   char sz_path[256] = "";
   GetModuleFileName(0, sz_path, 255);
   string p(sz_path);
   p.erase(p.find_last_of("\\") + 1, p.length());
   cpp = "\"" + p + cpp + "\"";
+#endif
 #endif // _WIN32
 
   base_dir = "";
